from ...services import project,printer, dag, validator
import json

def view(task=None, dag_only=False, validate=False):

    project.check_is_job_project()

    with open('./job.json', 'r') as f:
        obj = json.loads(f.read())

    if not dag_only and not task:
        # job Description
        printer.print_title('Job Description:')
        printer.print_job_desc(obj)

    #dependencies:
    deps = obj.get('TaskDag').get('Dependencies')
    #deps = {'Aaaa':['B','Colsl'], 'B':['D','Evvasdfadsfasdfasdfas'], 'Colsl':['G'], 'G':['H'],'D':['H']}
    deps = merge_deps(obj.get('TaskDag').get('TaskDescMap').keys(), deps)

    matric = dag.sortIndex(deps)

    if not task:
        printer.print_deps(deps, matric)

    if not dag_only:

        if task:
            #one task
            v = obj.get('TaskDag').get('TaskDescMap').get(task)
            if v:
                printer.print_title('Task Description for [%s]:' % task)
                printer.print_task_desc(task, v)
            else:
                raise Exception('Not found task %s' % task)

        else:

            if not dag_only:
                #all tasks
                printer.print_title('Task Descriptions:')
                task_descs = obj.get('TaskDag').get('TaskDescMap')

                c=0
                for n in matric:
                    for n2 in n:
                        c = c+1
                        if task_descs.get(n2):
                            printer.print_task_desc('%d.%s'% (c, n2), task_descs[n2])


    #validate
    if validate:
        msg = validator.validate_job(obj)

        if msg:
            printer.warn(msg)
        else:
            printer.done('OK')
        print('')



def transform_task(task):
    if task:
        return task
    else:
        return None

def merge_deps(key_set, deps):
    uniq_set = set()
    for n in deps:
        uniq_set.add(n)
        for k in deps[n]:
            uniq_set.add(k)

    for k in key_set:
        if k not in uniq_set:
            deps[k]=[]
    return deps


