#!/usr/bin/env python
# -*- coding: UTF-8 -*-
import os
from oss.oss_api import *
import Const

HOST = os.environ.get('ALI_BATCHCOMPUTE_OSS_HOST')
TASK_NAME = os.environ['ALI_BATCHCOMPUTE_TASK_ID']
INSTANCE_ID = os.environ['ALI_BATCHCOMPUTE_INSTANCE_ID']

# Your AccessKeyId, AccessKeySecret and bucket here
ACCESS_KEY_ID = Const.ACCESS_KEY_ID
ACCESS_KEY_SECRET = Const.ACCESS_KEY_SECRET
BUCKET = Const.BUCKET

# todo: 以下变量根据实际情况修改
FIND_INPUT_PATH = '' #'find-prime/input-data-%s.txt'
FIND_OUTPUT_PATH = '' #'find-prime/data/%s-result-%s'


oss = OssAPI(HOST, ACCESS_KEY_ID, ACCESS_KEY_SECRET)
res = oss.get_object(BUCKET, FIND_INPUT_PATH % INSTANCE_ID )

data = res.read()
data = [int(x) for x in data.split()]

def is_prime_num(n):
  if n <= 1:
    return False
  i=2
  while i * i <= n:
    if n % i == 0:
      return False
    i += 1
  return True

prime = [str(x) for x in data if is_prime_num(x)]
oss.put_object_from_string(BUCKET,  FIND_OUTPUT_PATH % (TASK_NAME, INSTANCE_ID), ' '.join(prime))